Index: main/trunk/greenstone2/runtime-src/packages/apache-httpd/README.txt
===================================================================
--- main/trunk/greenstone2/runtime-src/packages/apache-httpd/README.txt	(revision 22482)
+++ main/trunk/greenstone2/runtime-src/packages/apache-httpd/README.txt	(revision 22483)
@@ -1,18 +1,46 @@
-This Readme explains the customisations made to binary files and zipped files in this folder.
+***************************************** 
+README:
+runtime-src/packages/apache-httpd
+***************************************** 
 
-* The first is the Apache Httpd 2, whose unmodified source code was originally being compiled up on Linux alone. The first greenstone-modified version was added to include windows makefiles to compile these.
+This Readme explains the customisations made to binary files and
+zipped files in this folder.
 
 
-(A) FILE: httpd-2.2.11-gs.tar.gz
-Apache Httpd 2 src code with modifications for Greenstone
+* The first is the Apache Httpd 2, whose unmodified source code was
+  originally being compiled up on Linux alone. The first
+  greenstone-modified version was added to include windows makefiles
+  to compile these.
 
-This Readme file was originally created on July 22. The dates in the commit messages below, upto and including point 6, are relative to this.
+
+********************************************************************************************
+(A) FILE: httpd-2.2.11-gs.tar.gz: Apache Httpd 2 src code with
+modifications for Greenstone.
+********************************************************************************************
+
+This Readme file was originally created on 22 July 2010. The dates in
+the commit messages below, upto and including point 6, are relative to
+this.  Some more notes to do with Apache Httpd and how Greenstone
+compiles and installs (including upon Installation of Greenstone) are
+at the bottom.
+
+
+The httpd tar.gz file works with the files httpd.conf.in for linux and
+windows-httpd.conf.in for windows.
+http://trac.greenstone.org/browser/gsdl/trunk/runtime-src/packages/apache-httpd/windows-httpd.conf.in?rev=20171
+Revision 20171, 17.6 KB (checked in by ak19, 12 months ago) explains:
+"Windows httpd.conf.in file is not the same as the one for linux and
+darwin (Mac), since one gets the Modules Already Loaded message on
+Linux if the existing httpd.conf.in was interchanged with the Windows
+one."
 
 
 1. http://trac.greenstone.org/browser/gsdl/trunk/runtime-src/packages/apache-httpd/httpd-2.2.11-gs.tar.gz?rev=20169
 
-Revision 20169, 7.9 MB  (checked in by ak19, 12 months ago)
+Revision 20169, 7.9 MB (checked in by ak19, 12 months ago)
 
-Adding the customised apache web server source folder: a linux source release plus apache's official windows makefiles. Now it compiles up on both OS.
+Adding the customised apache web server source folder: a linux source
+release plus apache's official windows makefiles. Now it compiles up
+on both OS.
 
     * Property svn:mime-type set to application/octet-stream
@@ -21,7 +49,10 @@
 2. http://trac.greenstone.org/browser/gsdl/trunk/runtime-src/packages/apache-httpd/httpd-2.2.11-gs.tar.gz?rev=20349
 
-Revision 20349, 7.9 MB  (checked in by ak19, 11 months ago)
+Revision 20349, 7.9 MB (checked in by ak19, 11 months ago)
 
-Dr Bainbridge fixed the configure.in (and generated the configure file from it) so that it generates the libexpat.so.0 file it needs. This way the apache web server won't look elsewhere for the so file and perhaps find an incompatible version of it.
+Dr Bainbridge fixed the configure.in (and generated the configure file
+from it) so that it generates the libexpat.so.0 file it needs. This
+way the apache web server won't look elsewhere for the so file and
+perhaps find an incompatible version of it.
 
     * Property svn:mime-type set to application/octet-stream
@@ -30,7 +61,8 @@
 3. http://trac.greenstone.org/browser/gsdl/trunk/runtime-src/packages/apache-httpd/httpd-2.2.11-gs.tar.gz?rev=20668
 
-Revision 20668, 7.9 MB  (checked in by davidb, 10 months ago)
+Revision 20668, 7.9 MB (checked in by davidb, 10 months ago)
 
-better to include builtin libiconv support. Should prevent .so version conflicts on Mac
+better to include builtin libiconv support. Should prevent .so version
+conflicts on Mac
 
     * Property svn:mime-type set to application/octet-stream
@@ -39,7 +71,15 @@
 4. http://trac.greenstone.org/browser/gsdl/trunk/runtime-src/packages/apache-httpd/httpd-2.2.11-gs.tar.gz?rev=20850
 
-Revision 20850, 7.7 MB  (checked in by ak19, 9 months ago)
+Revision 20850, 7.7 MB (checked in by ak19, 9 months ago)
 
-Teaches the apache web server being compiled up where the static libiconv lib file, libiconv.a, is to be found (which greenstone would have compiled up during the greenstone configure stage). The with-iconv flag is set in runtime-src/packages/configure file to point to the common-src/packages/iconv folder wherein the lib folder contains the generated libiconv.a file. The apache server tar file is updated as well: no longer does it add the with-iconv flag explicitly since this is now already set at a higher up level and is passed down to it.
+Teaches the apache web server being compiled up where the static
+libiconv lib file, libiconv.a, is to be found (which greenstone would
+have compiled up during the greenstone configure stage). The
+with-iconv flag is set in runtime-src/packages/configure file to point
+to the common-src/packages/iconv folder wherein the lib folder
+contains the generated libiconv.a file. The apache server tar file is
+updated as well: no longer does it add the with-iconv flag explicitly
+since this is now already set at a higher up level and is passed down
+to it.
 
     * Property svn:mime-type set to application/octet-stream
@@ -47,5 +87,6 @@
 
 5. http://trac.greenstone.org/browser/gsdl/trunk/runtime-src/packages/apache-httpd/httpd-2.2.11-gs.tar.gz?rev=20892
-Revision 20892, 7.7 MB  (checked in by oranfry, 9 months ago)
+
+Revision 20892, 7.7 MB (checked in by oranfry, 9 months ago)
 
 the change I think will force apr not to use sendfile
@@ -57,8 +98,48 @@
 (http://trac.greenstone.org/browser/main/trunk/greenstone2/runtime-src/packages/apache-httpd/httpd-2.2.11-gs.tar.gz)
 
-Revision 20893, 7.9 MB  (checked in by ak19, 9 months ago)
+Revision 20893, 7.9 MB (checked in by ak19, 9 months ago)
 
-Dr Bainbridge updated srclib/apr/configure.in so that sendfile is set to 0 for Darwin (Mac) to tell Darwin systems that we won't be working with calls to sendfile, since Tiger OS does not have sendfile even though we are compiling on Leopard which does.
+Dr Bainbridge updated srclib/apr/configure.in so that sendfile is set
+to 0 for Darwin (Mac) to tell Darwin systems that we won't be working
+with calls to sendfile, since Tiger OS does not have sendfile even
+though we are compiling on Leopard which does.
 
     * Property svn:mime-type set to application/octet-stream
 
+
+
+*****************************************************************
+NOTES ON COMPILING AND INSTALLING APACHE HTTPD 2.2 FOR GREENSTONE
+*****************************************************************
+
+The Relocatable Apache web server:
+
+
+A) RELEASE KIT needs to run:
+
+1. ./configure --enable-apache-httpd
+2. make
+3. make install
+4. make apache-for-dist
+
+
+B) INSTALLER needs to:
+
+1. Copy the compiled up apache-httpd folder and put it into its
+   destination for installation:
+GSDLHOME/apache-httpd.
+
+X 2. Not necessary: 
+cd into there and into the linux (=GSDLOS) folder in there:
+	cd <GSDLHOME>/apache-httpd/linux
+
+3. Run the script install-bindist.sh (in apache-httpd/<GSDLOS> folder)
+   passing as argument: <GSDLHOME>/apache-httpd/linux
+
+4. Now it should be good to go: can run the webserver after
+   configuring the port (in linux/conf/httpd.conf) as follows
+	./bin/apachectl start
+
+- Change port in httpd.conf file
+- run gs2-server.sh
+