Index: /main/trunk/greenstone3/web/WEB-INF/web.xml
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/web.xml	(revision 22568)
+++ /main/trunk/greenstone3/web/WEB-INF/web.xml	(revision 22569)
@@ -96,5 +96,5 @@
     <init-param>
       <param-name>receptionist_class</param-name>
-      <param-value>SkinnedReceptionist</param-value>
+      <param-value>DefaultReceptionist</param-value>
     </init-param>
     <init-param>
@@ -103,4 +103,31 @@
     </init-param>
   </servlet>
+
+  <servlet>^M
+    <servlet-name>Format</servlet-name>^M
+    <description>A new skin engine still in development based on the standard gsdl3 library program</description>^M
+    <servlet-class>org.greenstone.gsdl3.LibraryServlet</servlet-class>^M
+    <init-param>^M
+      <param-name>library_name</param-name>^M
+      <param-value>format</param-value>^M
+    </init-param>^M
+    <init-param>^M
+      <param-name>site_name</param-name>^M
+      <param-value>localsite</param-value>^M
+    </init-param>^M
+    <init-param>^M
+      <param-name>interface_name</param-name>^M
+      <param-value>oran</param-value>^M
+    </init-param>^M
+    <init-param>^M
+      <param-name>receptionist_class</param-name>^M
+      <param-value>FormatReceptionist</param-value>^M
+    </init-param>^M
+    <init-param>^M
+      <param-name>default_lang</param-name>^M
+      <param-value>en</param-value>^M
+    </init-param>^M
+  </servlet>^M
+
   
   <servlet>
@@ -283,4 +310,10 @@
     <url-pattern>/dev</url-pattern>
   </servlet-mapping>
+
+  <servlet-mapping>^M
+    <servlet-name>Format</servlet-name>^M
+    <url-pattern>/format</url-pattern>^M
+  </servlet-mapping>^M
+
   <servlet-mapping>
     <servlet-name>gs2-library</servlet-name>
Index: /main/trunk/greenstone3/web/interfaces/default/transform/classifier.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/classifier.xsl	(revision 22568)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/classifier.xsl	(revision 22569)
@@ -60,5 +60,29 @@
       <xsl:with-param name="collName" select="$collName"/>
     </xsl:call-template>      
-    
+  
+    <!-- Sam's div code -->
+
+    <!-- <xsl:if test="/page/pageRequest[@name='output']='debug'"> -->
+
+    <xsl:variable name="fmt">
+	<xsl:call-template name="xml-to-string">
+            <xsl:with-param name="node-set" select="//format[@type='browse']"/>
+          </xsl:call-template>
+    </xsl:variable>
+
+    <!-- <xsl:variable name="tok" select="fn:tokenize($fmt,'/s+')"/> -->
+
+      <div id="format">
+        <p>
+	  <b>Format string here</b>
+	  <i>
+	      <xsl:value-of select="$fmt"/>
+	      <!-- <xsl:value-of select="$tok"/> -->
+	  </i>
+        </p>
+      </div>
+    <!-- </xsl:if> -->
+
+  
     <div id="content">
       <xsl:apply-templates select="service/classifierList">
Index: /main/trunk/greenstone3/web/interfaces/default/transform/util.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/util.xsl	(revision 22568)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/util.xsl	(revision 22569)
@@ -10,4 +10,6 @@
   <xsl:param name="interface_name"/>
   <xsl:param name="library_name"/>
+
+  <xsl:include href="xml-to-string.xsl"/>
   
   <!-- every pages ................................................. -->
Index: /main/trunk/greenstone3/web/interfaces/oran/js/gui_div.js
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/js/gui_div.js	(revision 22568)
+++ /main/trunk/greenstone3/web/interfaces/oran/js/gui_div.js	(revision 22569)
@@ -16,77 +16,102 @@
     $('a.remove').bind('click', removeContent);
 
-    /*    
-    $('div.blockWrapper').NestedSortable(
-    {
-        accept: 'block',
-        helperclass: 'sortHelper',
-        activeclass :   'sortableactive',
-        hoverclass :    'sortablehover',
-
-        // Restricts sort start click to the specified element.
-        handle: 'div.header',
-        onStart : function()
-            {
-                $.iAutoscroller.start(this, document.getElementsByTagName('body'));
+    $(".elementType").draggable({
+            connectToSortable: '.gsf_template',
+            helper: 'clone',
+            revert: 'invalid',
+            //start: function(event, ui) { ui.item.addClass('replaceMe');},
+            stop: function(event, ui) {
+                console.log("Stopped dragging - do we want to create element?"+ui.helper);
+                ui.helper.addClass('replaceMe');
             },
-            onStop : function()
-            {
-                $.iAutoscroller.stop();
+        });
+
+    /*
+    $('.elementType').sortable({
+            cursor: 'pointer',
+            tolerance: 'pointer',
+            //placeholder:'placeholder',
+            connectWith:'.gsf_template',
+            //cancel: '.elementType',
+            
+            start: function(event, ui) {
+                        $(this).clone().insertAfter(this);;
+            },
+
+    });
+    */
+    
+     function templateAdded() {
+         var item = $('.elementType');
+         // do something with "item" - its your new pretty cloned dropped item ;]
+         item.replaceWith('<h2>REPLACED</h2>');  
+         //item.addClass( 'added' );
+     };    
+ 
+    $('#formatStatement').sortable({
+            cursor: 'pointer',
+            tolerance: 'pointer',
+            items: '.gsf_template',
+            placeholder:'placeholder'
+            //'nested':'div'
+    });
+    
+    $('.gsf_template').sortable({
+            'cursor':'pointer',
+            'tolerance': 'pointer',
+            'items':'.table, .gsf_choose-metadata, .gsf_metadata',
+            'placeholder':'placeholder',
+            //'nested':'.gsf:metadata'
+            stop: function(event, ui) {
+                if (ui.item.hasClass("elementType") && ui.item.hasClass('css_gsf_template')) {
+                        ui.item.replaceWith(gsf_metadata_element); //'<div class="element element-txt">This text box has been added!</div>');
+                        //ui.item.style.border = 
+                }
             }
-    }
-    );
-    */
+
+            //receive: function(event, ui) { 
+            //    console.log("I have received an item");
+                //var item = $('.ui_sortable/.elementType');
+            //    var item = $('.div/.elementType'); //css_gsf_template not(.gsf_template)');
+            //    console.log(item);
+                //item.replaceWith('<h2>REPLACED</h2>');
+            //}
+
+    });
+
+    $('.td').sortable({
+            'cursor':'pointer',
+            'tolerance': 'pointer',
+            'items':'.leaf .gsf_choose-metadata, .gsf_link, .gsf_switch',
+            'placeholder':'placeholder'
+            //'nested':'.gsf:metadata'
+    });
  
-     
-    $('#formatStatement').sortable({
-            'cursor':'pointer',
-            'tolerance': 'pointer',
-            'items':'.gsf\\:template',
+    $('.gsf_choose-metadata').sortable({
+            'cursor':'pointer',
+            'tolerance': 'pointer',
+            'items':'.gsf_metadata',
             'placeholder':'placeholder',
-            //'nested':'div'
+            'connectWith':'.gsf_choose-metadata'
+            //'nested':'.gsf:metadata'
     });
     
-    $('.gsf\\:template').sortable({
-            'cursor':'pointer',
-            'tolerance': 'pointer',
-            'items':'.table, .gsf\\:choose-metadata, .gsf\\:metadata',
-            'placeholder':'placeholder'
-            //'nested':'.gsf:metadata'
-    });
-
-    $('.table').sortable({
-            'cursor':'pointer',
-            'tolerance': 'pointer',
-            'items':'.leaf .gsf\\:choose-metadata, .gsf\\:link, .gsf\\:switch',
-            'placeholder':'placeholder'
-            //'nested':'.gsf:metadata'
-    });
- 
-    $('.gsf\\:choose-metadata').sortable({
-            'cursor':'pointer',
-            'tolerance': 'pointer',
-            'items':'.gsf\\:metadata',
-            'placeholder':'placeholder',
-            'connectWith':'.gsf\\:choose-metadata'
-            //'nested':'.gsf:metadata'
-    });
-    
-    $('.gsf\\:link').sortable({
-            'cursor':'pointer',
-            'tolerance': 'pointer',
-            'items':'.gsf\\:icon',
-            'placeholder':'placeholder'
-            //'nested':'.gsf:metadata'
-    });
-
-    $('.gsf\\:switch').sortable({
-            'cursor':'pointer',
-            'tolerance': 'pointer',
-            'items':'.gsf\\:metadata, .gsf\\:when, .gsf\\otherwise',
-            'placeholder':'placeholder'
-            //'nested':'.gsf:metadata'
-    });
-
-    $('.gsf\\:when').sortable({
+    $('.gsf_link').sortable({
+            'cursor':'pointer',
+            'tolerance': 'pointer',
+            'items':'.gsf_icon',
+            'placeholder':'placeholder'
+            //'nested':'.gsf:metadata'
+    });
+
+    $('.gsf_switch').sortable({
+            'cursor':'pointer',
+            'tolerance': 'pointer',
+            'items':'.gsf_metadata, .gsf_when, .gsf_otherwise',
+            'placeholder':'placeholder'
+            //'nested':'.gsf:metadata'
+    });
+
+    $('.gsf_when').sortable({
             'cursor':'pointer',
             'tolerance': 'pointer',
@@ -96,5 +121,5 @@
     });
 
-    $('.gsf\\:otherwise').sortable({
+    $('.gsf_otherwise').sortable({
             'cursor':'pointer',
             'tolerance': 'pointer',
@@ -104,35 +129,16 @@
     });
 
-    /* 
-    $('div.blockWrapper').sortable(
-        {
-            accept: 'block',
-            helperclass: 'sortHelper',
-            activeclass :   'sortableactive',
-            hoverclass :    'sortablehover',
-
-            // Restricts sort start click to the specified element.
-            handle: 'div.header',
-
-            // This is the way the reordering behaves during drag. Possible values: 'intersect', 'pointer'. In some setups, 'pointer' is more natural.
-            // * intersect: draggable overlaps the droppable at least 50%
-            // * pointer: mouse pointer overlaps the droppable
-            tolerance: 'pointer',
-            //containment: 'parent',
-            nested: 'div',
-            onChange : function(ser)
-            {
-            },
-            onStart : function()
-            {
-                $.iAutoscroller.start(this, document.getElementsByTagName('body'));
-            },
-            onStop : function()
-            {
-                $.iAutoscroller.stop();
-            }
-        }
-    );
-    */
+    //$(".resizable").resizable({containment: 'parent', alsoResize:'parent'});
+
+    $('.tr').equalHeights();
+
+    $(".td").resizable({
+                alsoResize: 'parent',
+                //containment: 'parent',
+                handles: 'e,s',
+                stop: function(event, ui) {
+                        $(this).parent().parent().equalHeights();
+                }, });
+
 
     $(".block").mouseover(function() 
@@ -175,3 +181,41 @@
 };
 
-
+/*-------------------------------------------------------------------- 
+ * JQuery Plugin: "EqualHeights"
+ * by:  Scott Jehl, Todd Parker, Maggie Costello Wachs (http://www.filamentgroup.com)
+ *
+ * Copyright (c) 2008 Filament Group
+ * Licensed under GPL (http://www.opensource.org/licenses/gpl-license.php)
+ *
+ * Description: Compares the heights or widths of the top-level children of a provided element 
+        and sets their min-height to the tallest height (or width to widest width). Sets in em units 
+        by default if pxToEm() method is available.
+ * Dependencies: jQuery library, pxToEm method  (article: 
+        http://www.filamentgroup.com/lab/retaining_scalable_interfaces_with_pixel_to_em_conversion/)                              
+ * Usage Example: $(element).equalHeights();
+        Optional: to set min-height in px, pass a true argument: $(element).equalHeights(true);
+ * Version: 2.0, 08.01.2008
+--------------------------------------------------------------------*/
+
+// Modified to get children of children ie. tr -> td -> div
+
+$.fn.equalHeights = function(px) {
+    console.log("EQUAL HEIGHTS");
+    $(this).each(function(){
+        var currentTallest = 0;
+        console.log($(this).children());
+        console.log($(this).children().children());
+        //$(this).children().children().each(function(i){
+        //    console.log($(this));
+        //    console.log("THIS HEIGHT="+$(this).height()+ " CURRENT TALLEST="+ currentTallest);
+            //if ($(this).height() > currentTallest) { currentTallest = $(this).height(); }
+            //if ($(this).height() > currentTallest) { currentTallest = $(this).height(); }
+        //});
+        //if (!px || !Number.prototype.pxToEm) currentTallest = currentTallest.pxToEm(); //use ems unless px is specified
+        // for ie6, set height since min-height isn't supported
+        //if ($.browser.msie && $.browser.version == 6.0) { $(this).children().children().css({'height': $(this).currentTallest}); }
+        $(this).children().children().css({'height': $(this).height()}); //currentTallest}); 
+    });
+    return this;
+};
+
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/main.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/main.xsl	(revision 22568)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/main.xsl	(revision 22569)
@@ -31,5 +31,7 @@
 				<title><xsl:call-template name="pageTitle"/> :: <xsl:call-template name="siteName"/></title>
 				<link rel="stylesheet" href="interfaces/{$interface_name}/style/core.css" type="text/css"/>
-				<script type="text/javascript" src="interfaces/oran/js/jquery.js"><xsl:text> </xsl:text></script> 
+				<!-- <script type="text/javascript" src="interfaces/oran/js/jquery.js"><xsl:text> </xsl:text></script> --> 
+                <script type="text/javascript" src="interfaces/oran/js/jquery-1.4.2.min.js"><xsl:text> </xsl:text></script>
+                <script type="text/javascript" src="interfaces/oran/js/jquery-ui-1.8.2.custom.min.js"><xsl:text> </xsl:text></script>
                 <!-- <script type="text/javascript" src="http://code.jquery.com/jquery-1.4.2.min.js"><xsl:text> </xsl:text></script> -->
                 <!-- <script type="text/javascript" src="interfaces/oran/js/jquery-ui-1.8rc1/jquery-1.4.1.js"><xsl:text> </xsl:text></script> -->
@@ -121,9 +123,9 @@
     <!-- <script type="text/javascript" src="http://code.jquery.com/jquery-latest.min.js"><xsl:text> </xsl:text></script> --> 
     <!-- <script type="text/javascript" src="/interface/interface.js"><xsl:text> </xsl:text></script> -->
-    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.7.2/jquery-ui.js"><xsl:text> </xsl:text></script>
+    <!-- <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.7.2/jquery-ui.js"><xsl:text> </xsl:text></script> -->
     <!-- <script language="JavaScript" src="http://stats.byspirit.ro/track.js" type="text/javascript"><xsl:text> </xsl:text></script> -->
 
     <!-- <script type="text/javascript" src="interfaces/oran/js/interface/interface.js"><xsl:text> </xsl:text></script> -->
-    <script type="text/javascript" src="interfaces/oran/js/ui.nestedSortable.js"><xsl:text> </xsl:text></script>
+    <!-- <script type="text/javascript" src="interfaces/oran/js/ui.nestedSortable.js"><xsl:text> </xsl:text></script> -->
     <!-- <script type="text/javascript" src="interfaces/oran/js/inestedsortable.js"> <xsl:text> </xsl:text></script> -->
     <script type="text/javascript" src="interfaces/oran/js/gui_div.js"><xsl:text> </xsl:text></script>
@@ -148,7 +150,16 @@
             height:20px;
         }
+
+        .resizable { width: 150px; height: 150px; padding: 0.5em; } 
+
+        <!-- .gsf_metadata { border: solid 2px #0000BB; background-color: #440077; } -->
+
+        <!-- .gsf_choose-metadata { border: solid 1px #000000; background-color: #223344; } -->
     </style>
 
-    <table width="80%"> 
+    <link rel="stylesheet" type="text/css" href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.7.1/themes/base/jquery-ui.css"/> 
+
+
+    <table width="100%" border="1"> 
 
     <td width="60%">
@@ -164,17 +175,15 @@
     </td>    
 
+
     <td width="40%" valign="top">
-    <div class="gsf:metadata block leaf" title="gsf:metadata" id="gsf:metadata-{generate-id()}">
-            <!--<div class="header">-->
-                METADATA
-            <!--</div>-->
-            <!--<div class="content">-->
-                <xsl:call-template name="meta-to-combo">
-                    <xsl:with-param name="metadataSets" select="//metadataSetList"/>
-                    <xsl:with-param name="current" select="ex.Title"/>
-                </xsl:call-template>
-                <!-- <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a> -->
-            <!--</div>-->
-        </div>
+        <h2> Elements to add </h2>
+        <div class="elementType css_gsf_template" title="gsf:metadata">NEW GSF:TEMPLATE</div>
+        <div class="elementType css_gsf_choose-metadata" title="gsf:metadata">NEW GSF:CHOOSE-METADATA</div>
+        <div class="elementType css_gsf_metadata" title="gsf:metadata">NEW GSF:METADATA</div>
+        <br/>
+        <div class="elementType css_table" title="gsf:metadata">NEW TABLE</div>
+        <div class="elementType css_tr" title="gsf:metadata">NEW TABLE ROW</div>
+        <div class="elementType css_td" title="gsf:metadata">NEW TABLE COLUMN</div>
+
     </td>
     </table>
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/xml-to-gui.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/xml-to-gui.xsl	(revision 22568)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/xml-to-gui.xsl	(revision 22569)
@@ -20,5 +20,7 @@
 <xsl:stylesheet version="1.0"
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
-    xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat">
+    xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
+    xmlns:exsl="http://exslt.org/common"
+    extension-element-prefixes="exsl" >    
 
     <xsl:output omit-xml-declaration="yes"/>
@@ -44,6 +46,6 @@
         </xsl:apply-templates>
     </xsl:template>
-
-    
+    <!-- **************************************************************************** -->
+
     <!-- **************************************************************************** -->
     <!-- COMBO BOX CREATION                                                           -->
@@ -106,5 +108,4 @@
     <!-- **************************************************************************** -->
 
-
     <!-- **************************************************************************** -->
     <!-- GSF STATEMENTS                                                               -->
@@ -116,19 +117,13 @@
         <xsl:param name="depth"/>
         <xsl:param name="metadataSets"/>
-        
-        <div class="gsf:choose-metadata block" title="gsf:choose-metadata" id="gsf:choose-metadata-{generate-id()}">
-            <!-- <div class="header"> -->
+
+        <div class="gsf_choose-metadata css_gsf_choose-metadata block" title="gsf:choose-metadata">
                 CHOOSE <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
-            <!--</div>-->
-            <!--<div class="content">-->
                 <xsl:apply-templates mode="xml-to-gui">
                     <xsl:with-param name="depth" select="$depth"/>
                     <xsl:with-param name="metadataSets" select="$metadataSets"/> 
                 </xsl:apply-templates>
-            <!--</div>-->
-            <!--<div class="footer">-->
                 END CHOOSE
-            <!--</div>-->
-        </div>    
+        </div>   
     </xsl:template>
 
@@ -139,16 +134,27 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="gsf:metadata block leaf" title="gsf:metadata" id="gsf:metadata-{generate-id()}">
-            <!--<div class="header">-->
-                METADATA 
-            <!--</div>-->
-            <!--<div class="content">-->
-                <xsl:call-template name="meta-to-combo">
-                    <xsl:with-param name="metadataSets" select="$metadataSets"/>
-                    <xsl:with-param name="current" select="@name"/>
-                </xsl:call-template>
-                <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
-            <!--</div>-->
-        </div>
+        <xsl:variable name="one">
+        <div class="gsf_metadata css_gsf_metadata block leaf" title="gsf:metadata">METADATA <xsl:call-template name="meta-to-combo">
+                        <xsl:with-param name="metadataSets" select="$metadataSets"/>
+                        <xsl:with-param name="current" select="@name"/>
+                     </xsl:call-template> <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
+        </div>
+        </xsl:variable>
+
+      
+        <xsl:variable name="meta">
+        <xsl:call-template name="xml-to-string">
+            <xsl:with-param name="node-set" select="exsl:node-set($one)"/>
+        </xsl:call-template>
+        </xsl:variable>
+
+        <xsl:copy-of select="$one"/>
+
+        <br/>
+        <script type="text/javascript">
+            gsf_metadata_element = <xsl:text disable-output-escaping="yes">'</xsl:text><xsl:copy-of select="$one" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">';</xsl:text> 
+
+        </script>
+
     </xsl:template>
 
@@ -158,6 +164,6 @@
         <xsl:param name="depth"/>
         <xsl:param name="metadataSets"/>
-        
-        <div class="gsf:link block" title="gsf:link" id="gsf:link-{generate-id()}">
+
+        <div class="gsf_link css_gsf_link block" title="gsf:link">
                 LINK[type=
     	        <select>
@@ -200,10 +206,23 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="gsf:template block" title="gsf:template" id="gsf:template-{generate-id()}">
+            <!-- CHILD = <xsl:value-of select="child[1]/@name"/> -->
+            <!-- CHILD = <xsl:value-of select="child::*[name()][1]"/> -->
+
+
+            <!-- <xsl:for-each select="child::*"> -->
+            <!-- <xsl:value-of select="name()"/> -->
+            <!-- </xsl:for-each> -->
+
+
+        <div class="gsf_template block" title="gsf:template">
                 TEMPLATE[match=<xsl:value-of select="@match"/>]<a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
+                <table border="1">
+                <tr class="tr">
                 <xsl:apply-templates mode="xml-to-gui">
                     <xsl:with-param name="depth" select="$depth"/>
                     <xsl:with-param name="metadataSets" select="$metadataSets"/> 
                 </xsl:apply-templates>
+                </tr>
+                </table>
                 END TEMPLATE <br/>
         </div>
@@ -215,5 +234,5 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="gsf:switch block" title="gsf:switch" id="gsf:switch-{generate-id()}">
+        <div class="gsf_switch block" title="gsf:switch">
                 SWITCH <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
                 <xsl:apply-templates mode="xml-to-gui">
@@ -231,5 +250,5 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="gsf:when block" title="gsf:when" id="gsf:when-{generate-id()}"> 
+        <div class="gsf_when block" title="gsf:when"> 
                 WHEN[test=<xsl:value-of select="@test"/>] <br/><a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
                 <xsl:apply-templates mode="xml-to-gui">
@@ -247,5 +266,5 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="gsf:otherwise block" title="gsf:otherwise" id="gsf:otherwise-{generate-id()}">
+        <div class="gsf_otherwise block" title="gsf:otherwise">
                 OTHERWISE <br/><a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
                 <xsl:apply-templates mode="xml-to-gui">
@@ -263,5 +282,5 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="gsf:icon block leaf" title="gsf:icon" id="gsf:icon-{generate-id()}">
+        <div class="gsf_icon block leaf" title="gsf:icon">
                 ICON[type=
                 <select>
@@ -293,17 +312,11 @@
         <xsl:param name="metadataSets"/>
 
-        <div class="block" title="gsf:default" id="gsf:default-{generate-id()}">
-            <div class="header">
+        <div class="block" title="gsf:default">
                 DEFAULT <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
-            </div>
-            <div class="content">
                 <xsl:apply-templates mode="xml-to-gui">
                     <xsl:with-param name="depth" select="$depth"/>
                     <xsl:with-param name="metadataSets" select="$metadataSets"/>
                 </xsl:apply-templates>
-            </div>
-            <div class="footer">
                 END DEFAULT
-            </div>
         </div>
     </xsl:template>
@@ -315,5 +328,5 @@
         <xsl:param name="metadataSets"/>
         
-        <div class="block leaf" title="gsf:text" id="gsf:text-{generate-id()}">
+        <div class="block leaf" title="gsf:text">
                 TEXT <a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
                 <xsl:variable name="rawtext"><xsl:value-of select="."/></xsl:variable>
@@ -327,13 +340,17 @@
         <xsl:param name="depth"/>
         <xsl:param name="metadataSets"/>
-
-        <div class="table block" title="gsf:table" id="gsf:table-{generate-id()}">
-                <xsl:text>&lt;td</xsl:text>valign=<xsl:value-of select="@valign"/><xsl:text>&gt;</xsl:text><a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a>
+        
+
+        <!-- <td class="td block resizable" title="td" valign="{@valign}" style='overflow: hidden;'> -->
+        <td valign="{@valign}" title="td">
+            <div class="td block" title="td-div">
+            <!-- <xsl:text>&lt;td</xsl:text>valign=<xsl:value-of select="@valign"/><xsl:text>&gt;</xsl:text><a href="#" class="minmax">[-]</a><a href="#" class="remove">[x]</a> -->
                 <xsl:apply-templates mode="xml-to-gui">
                     <xsl:with-param name="depth" select="$depth"/>
                     <xsl:with-param name="metadataSets" select="$metadataSets"/> 
                 </xsl:apply-templates>
-                <xsl:text>&lt;/td&gt;</xsl:text><br/><br/>
-        </div>
+                <!-- <xsl:text>&lt;/td&gt;</xsl:text><br/><br/> -->
+            </div>
+        </td>
     </xsl:template>
 
Index: /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml
===================================================================
--- /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml	(revision 22568)
+++ /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgdemo/etc/collectionConfig.xml	(revision 22569)
@@ -77,24 +77,3 @@
     </display>
     <replaceListRef id="gs2-standard"/>
-  <serviceRackList>
-    <!-- comment out the following serviceRack if you want to disable OAI for this collection -->
-    <serviceRack name="OAIPMH">
-        <ListMetadataFormats>
-	<!--What metadata sets to support is collection specific. To support other metadata schema, simply add a metadataFormat element here.
-	The support of unqualified Dublin Core metadata set is mendatory in the oai specification.
-      -->
-	<metadataFormat metadataPrefix="oai_dc">
-	  <metadataPrefix>oai_dc</metadataPrefix>
-	  <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
-	  <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
-	  <!--   a custom mapping as this collection doesn't have dc metadata -->     <mappingList>
-	    <mapping>dc:title,dls.Title</mapping>
-	    <mapping>dc:subject,dls.Subject</mapping>
-	    <mapping>dc:language,dls.Language</mapping>
-	    <mapping>dc:publisher,dls.Organization</mapping>
-	  </mappingList>
-	</metadataFormat>
-      </ListMetadataFormats>
-    </serviceRack> 
-  </serviceRackList>
 </CollectionConfig>
Index: /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgppdemo/etc/collectionConfig.xml
===================================================================
--- /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgppdemo/etc/collectionConfig.xml	(revision 22568)
+++ /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgppdemo/etc/collectionConfig.xml	(revision 22569)
@@ -40,7 +40,5 @@
             <option name="stem"/>
         </indexOption>
-        <searchType name="plain"/>
-        <searchType name="simpleform"/>
-        <searchType name="advancedform"/>
+        <format name="searchType">plain,form</format>
         <format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td><gsf:switch><gsf:metadata name="Title" select="ancestors" separator=": "/><gsf:when test="exists"><gsf:metadata name="Title" select="ancestors" separator=": "/>:</gsf:when></gsf:switch><gsf:link type="document"><gsf:metadata name="Title"/></gsf:link></td></gsf:template></format>
     </search>
@@ -84,24 +82,3 @@
     </display>
     <replaceListRef id="gs2-standard"/>
-  <serviceRackList>
-    <!-- comment out the following serviceRack if you want to disable OAI for this collection -->
-    <serviceRack name="OAIPMH">
-        <ListMetadataFormats>
-	<!--What metadata sets to support is collection specific. To support other metadata schema, add another metadataFormat element here.
-	The support of unqualified Dublin Core metadata set is mandatory in the oai specification.
-      -->
-	<metadataFormat metadataPrefix="oai_dc">
-	  <metadataPrefix>oai_dc</metadataPrefix>
-	  <schema>http://www.openarchives.org/OAI/2.0/oai_dc.xsd</schema>
-	  <metadataNamespace>http://www.openarchives.org/OAI/2.0/oai_dc/</metadataNamespace>
-	  <!--   a custom mapping as this collection doesn't have dc metadata -->     <mappingList>
-	    <mapping>dc:title,dls.Title</mapping>
-	    <mapping>dc:subject,dls.Subject</mapping>
-	    <mapping>dc:language,dls.Language</mapping>
-	    <mapping>dc:publisher,dls.Organization</mapping>
-	  </mappingList>
-	</metadataFormat>
-      </ListMetadataFormats>
-    </serviceRack> 
-  </serviceRackList>
 </CollectionConfig>
Index: /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgppdemo/gs2mgppdemo.col
===================================================================
--- /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgppdemo/gs2mgppdemo.col	(revision 22568)
+++ /main/trunk/greenstone3/web/sites/localsite/collect/gs2mgppdemo/gs2mgppdemo.col	(revision 22569)
@@ -16,6 +16,25 @@
     <GathererConfig/>
     <BuildConfig>
-        <Build/>
-        <Import/>
+        <Build>
+            <Argument enabled="false" name="sections_index_document_metadata">never</Argument>
+            <Argument enabled="false" name="faillog"/>
+            <Argument enabled="false" name="index"/>
+            <Argument enabled="false" name="language"/>
+            <Argument enabled="false" name="maxnumeric">4</Argument>
+            <Argument enabled="false" name="mode">all</Argument>
+            <Argument enabled="false" name="verbosity">0</Argument>
+        </Build>
+        <Import>
+            <Argument enabled="false" name="maxdocs">1</Argument>
+            <Argument enabled="false" name="OIDtype">hash</Argument>
+            <Argument enabled="false" name="OIDmetadata"/>
+            <Argument enabled="false" name="sortmeta"/>
+            <Argument enabled="false" name="groupsize">1</Argument>
+            <Argument enabled="false" name="saveas">GreenstoneXML</Argument>
+            <Argument enabled="false" name="faillog"/>
+            <Argument enabled="false" name="removeprefix"/>
+            <Argument enabled="false" name="removesuffix"/>
+            <Argument enabled="false" name="verbosity">0</Argument>
+        </Import>
     </BuildConfig>
 </GathererCollection>